/* Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var CAM={};(function(e){var t=function(){function e(e,t){throw this.message=e,this.activityExecution=t,e}return e}(),n={},r="start",i="end",s="take",o=function(e,t,n){var r=[];for(var i=0;i<e.baseElements.length;i++){var s=e.baseElements[i];!!s.type&&s.type==t&&(r.push(s),n&&(r=r.concat(o(s,t,n))))}return r},u=function(e,t){for(var n=0;n<e.baseElements.length;n++){var r=e.baseElements[n];if(!!r.id&&r.id==t)return r}return null},a=function(e){var t=e.type;return t?n[t]:null},f=function(e,t){var n=[];if(!!e.outgoing){var r=e.outgoing;for(var i=0;i<r.length;i++){var s=r[i];n.push(u(t,s))}}return n},l=function(){function e(e,n){if(!e)throw new t("Activity definition cannot be null",this);this.activityDefinition=e,this.activityExecutions=[],this.isEnded=!1,this.parentExecution=n,this.variables={},this.startDate=null,this.endDate=null}return e.prototype.bindVariableScope=function(e){!this.parentExecution||this.parentExecution.bindVariableScope(e);var t=this.variables;for(var n in t)e[n]=t[n]},e.prototype.executeActivities=function(e){for(var t=0;t<e.length;t++)this.executeActivity(e[t])},e.prototype.executeActivity=function(t,n){var r=new e(t,this);this.activityExecutions.push(r),!n||(r.incomingSequenceFlowId=n.id),r.start()},e.prototype.invokeListeners=function(e,t){var n=this.activityDefinition.listeners;if(!!n)for(var r=0;r<n.length;r++){var i=n[r];!i[e]||i[e](this,t)}},e.prototype.start=function(){this.startDate=new Date,this.invokeListeners(r),this.activityDefinition.asyncCallback?this.activityDefinition.asyncCallback(this):this.continue()},e.prototype.continue=function(){var e=a(this.activityDefinition);e.execute(this)},e.prototype.end=function(e){this.isEnded=!0,this.endDate=new Date,this.invokeListeners(i);if(!!this.parentExecution){var t=this.parentExecution;e&&t.hasEnded(this)}},e.prototype.takeAll=function(e){for(var t=0;t<e.length;t++)this.take(e[t])},e.prototype.take=function(e){var n=e.targetRef,r=u(this.parentExecution.activityDefinition,n);if(!r)throw new t("cannot find activity with id '"+n+"'");this.end(!1),this.invokeListeners(s,e),this.parentExecution.executeActivity(r,e)},e.prototype.signal=function(e){var n=function(e){if(e.isEnded)throw new t("cannot signal an ended activity instance",e);var n=a(e.activityDefinition);n.signal?n.signal(e):e.end()};if(e)for(var r in this.activityExecutions){var i=this.activityExecutions[r];if(i.activityDefinition.id==e){n(i);break}}else n(this)},e.prototype.hasEnded=function(e){var t=!0;for(var n;n<this.activityExecutions.length;n++)t&=this.activityExecutions[n].isEnded;if(t){var r=a(this.activityDefinition);r.allActivitiesEnded?r.allActivitiesEnded(this):this.end()}},e.prototype.getActivityInstance=function(){var e={activityId:this.activityDefinition.id,isEnded:this.isEnded,startDate:this.startDate,endDate:this.endDate};if(this.activityExecutions.length>0){e.activities=[];for(var t=0;t<this.activityExecutions.length;t++)e.activities.push(this.activityExecutions[t].getActivityInstance())}return e},e}();e.ActivityExecution=l,e.ExecutionException=t,e.activityTypes=n,e.getActivitiesByType=o,e.getActivityById=u,e.getActivityType=a,e.getSequenceFlows=f,e.LISTENER_START=r,e.LISTENER_END=i,e.LISTENER_TAKE=s})(CAM),function(CAM){function evaluateCondition(e,t){return(new VariableScope(t)).evaluateCondition(e)}function leave(e){var t=[],n=CAM.getSequenceFlows(e.activityDefinition,e.parentExecution.activityDefinition),r=e.activityDefinition.default,i=null,s=!0;for(var o=0;o<n.length;o++){var u=n[o];!r||r!=u.id?u.condition?evaluateCondition(u.condition,e)&&(t.push(u),s=!1):t.push(u):i=u}s&&!!i&&t.push(i),e.takeAll(t)}var VariableScope=function(){function VariableScope(e){e.bindVariableScope(this)}return VariableScope.prototype.evaluateCondition=function(condition){return eval(condition)},VariableScope}(),process={execute:function(e){var t=CAM.getActivitiesByType(e.activityDefinition,"startEvent");if(t.length==0)throw"process must have at least one start event";e.executeActivities(t)}},startEvent={execute:function(e){leave(e)}},intermediateThrowEvent={execute:function(e){leave(e)}},endEvent={execute:function(e){e.end(!0)}},task={execute:function(e){leave(e)}},userTask={execute:function(e){},signal:function(e){leave(e)}},serviceTask={execute:function(e){leave(e)}},exclusiveGateway={execute:function(e){var t=e.activityDefinition.sequenceFlows,n,r;for(var i=0;i<t.length;i++){var s=t[i];if(!s.condition)r=s;else if(evaluateCondition(s.condition,e)){n=s;break}}if(!n){if(!r)throw"Cannot determine outgoing sequence flow for exclusive gateway '"+e.activityDefinition+"': "+"All conditions evaluate to false and a default sequence flow has not been specified.";n=r}e.take(n)}},parallelGateway={execute:function(e){var t=CAM.getSequenceFlows(e.activityDefinition,e.parentExecution.activityDefinition),n=[],r=e.parentExecution;for(var i=0;i<r.activityExecutions.length;i++){var s=r.activityExecutions[i];s.activityDefinition==e.activityDefinition&&!s.isEnded&&n.push(s)}if(n.length==e.activityDefinition.cardinality){for(var i=0;i<n.length;i++){var o=n[i];o!=e&&o.end(!1)}e.takeAll(t)}}};CAM.activityTypes.startEvent=startEvent,CAM.activityTypes.intermediateThrowEvent=intermediateThrowEvent,CAM.activityTypes.endEvent=endEvent,CAM.activityTypes.exclusiveGateway=exclusiveGateway,CAM.activityTypes.task=task,CAM.activityTypes.userTask=userTask,CAM.activityTypes.serviceTask=serviceTask,CAM.activityTypes.process=process,CAM.activityTypes.parallelGateway=parallelGateway}(CAM),typeof define=="function"&&define("bpmn/Executor",[],function(){return CAM}),define("bpmn/Transformer",[],function(){function i(e){var t;if(e instanceof Document)t=e;else if(window.DOMParser){var n=new DOMParser;t=n.parseFromString(e,"text/xml")}else t=new ActiveXObject("Microsoft.XMLDOM"),t.async=!1,t.loadXML(e);return t}function s(){this.parseListeners=[]}function o(e){return new Error(e)}var e="http://www.omg.org/spec/BPMN/20100524/MODEL",t="http://www.omg.org/spec/BPMN/20100524/DI",n="http://www.omg.org/spec/DD/20100524/DC",r="http://www.omg.org/spec/DD/20100524/DI";return s.prototype.transform=function(n){function c(t,n,r){function c(e,t){for(var n=0;n<e.childNodes.length;n++)if(e.childNodes[n].localName==t)return e.childNodes[n]}var i={};!n||n.baseElements.push(i);var s=t.attributes;i.type=t.localName;for(var o=0;s!=null&&o<s.length;o++){var u=s[o];i[u.nodeName]=u.nodeValue}if(i.type=="textAnnotation"){var a=t.getElementsByTagNameNS(e,"text")[0].firstChild.data;i.text=a}var f=r[i.id];!f||(i.bpmndi=f),i.id||(i.id=i.type+"_"+l,l++);var h=c(t,"multiInstanceLoopCharacteristics"),p=c(t,"standardLoopCharacteristics");return i.marker={},h&&h.getAttribute("isSequential")==="true"?i.marker.multiInstanceSequential=!0:h&&(i.marker.multiInstanceParallel=!0),p&&(i.marker.loop=!0),i.isForCompensation=="true"&&(i.marker.compensation=!0),i}function h(e,t,n,r){var i=c(e,t,r);i.outgoing=[],i.listeners=[],i.properties={};var s=e.attributes;if(!!n){var u=n[i.id];if(!!u){for(var a=0;a<u.length;a++)i.outgoing.push(u[a].id);if(!!i.default&&f){var l=!1;for(var a=0;a<u.length;a++){var h=u[a];if(!!h.condition){if(i.defaultFlowId==h.id)throw o("Sequence flow with id '"+h.id+"' is configured to be the default flow but has a condition");l=!0}}if(!l)throw o("Activity with id '"+i.id+"' declares default flow with id '"+i.default+"' but has no conditional flows.")}}}return i}function p(e,t,n,r){var i=h(e,t,n,r);return i}function d(t,n,r){var i=c(t,n,r),s=t.getElementsByTagNameNS(e,"dataInput"),o=t.getElementsByTagNameNS(e,"dataOutput"),u=[];for(var a=0;a<s.length;a++)u.push(c(s[a],n,r));for(var a=0;a<o.length;a++)u.push(c(o[a],n,r));return i.baseElements=u,i}function v(e,t,n){if(e.childNodes.length==0)return;var r=e.firstChild;do{var i=r.nodeName;i=="lane",c(r,t,n)}while(r=r.nextSibling)}function m(e,t,n,r){var i=h(e,t,n,r);i.eventDefinitions=[];var s=e.firstChild;if(!!s)do if(s.nodeName.indexOf("EventDefinition")!=-1){var o=s.nodeName;o.indexOf(":")!=-1&&(o=o.substr(o.indexOf(":")+1,o.length)),i.eventDefinitions.push({type:o})}while(s=s.nextSibling);return i}function g(t,n,r,i){var s=c(t,n,r);!s.sourceRef||(i[s.sourceRef]||(i[s.sourceRef]=[]),i[s.sourceRef].push(s));var o=t.getElementsByTagNameNS(e,"conditionExpression");if(!!o&&o.length>0){var u=o[0];s.condition=u.textContent}return s.properties={},s}function y(e,t,n){e=e.firstChild;var r={};if(!e)return r;do(e.nodeName=="sequenceFlow"||e.localName=="sequenceFlow")&&g(e,t,n,r);while(e=e.nextSibling);return r}function b(e,t,n,r){var i=h(e,t,n,r),s=0;for(var o in n){var u=n[o];for(var a=0;a<u.length;a++)u[a].targetRef==i.id&&s++}return i.cardinality=s,i}function w(e,t,n,r){var i=h(e,t,null,r),s=i.sequenceFlows,u=i.default;if(!!n&&f){var s=n[i.id];if(!!s){i.sequenceFlows=s;if(s.length==1){if(!!s[0].condition)throw o("If an exclusive Gateway has a single outgoing sequence flow, the sequence flow is not allowed to have a condition.")}else if(s.length>1){var a=[];for(var l=0,c;!!(c=s[l]);l++){var p=!!c.condition,d=u===c.id;!p&&!d&&a.push(c);if(p&&d)throw o("Sequence flow with id '"+c.id+"' is configured to be the default flow but has a condition.")}if(!!u&&a.length>0||a.length>1)throw o("Exclusive Gateway '"+i.id+"' has outgoing sequence flows without conditions which are not the default flow.");!u&&a.length===1&&console.log("[Transformer]: Sequence flow with id '"+a[0].id+"' has no conditions but it is not configured to be the default flow.")}}}return i}function E(e,t,n,i){for(var s=0;s<r.length;s++){var o=r[s];o(e,t,n,i)}}function S(e,t,n){t.baseElements=[];var r=y(e,t,n),i=e.firstChild;if(!i)return;do{var s=null,o=i.nodeName;o.indexOf(":")!=-1&&(o=o.substr(o.indexOf(":")+1,o.length));var u=["callActivity","task","manualTask","serviceTask","scriptTask","userTask","sendTask","recieveTask","businessRuleTask"],a=["startEvent","endEvent","intermediateThrowEvent","intermediateCatchEvent","boundaryEvent"];o=="exclusiveGateway"?s=w(i,t,r,n):o=="parallelGateway"?s=b(i,t,r,n):u.indexOf(o)!=-1?s=p(i,t,r,n):a.indexOf(o)!=-1?s=m(i,t,r,n):o=="laneSet"?s=v(i,t,n):o=="subProcess"||o=="adHocSubProcess"||o=="transaction"?s=T(i,t,r,n):o=="ioSpecification"?s=d(i,t,n):!!i&&i.nodeName!="sequenceFlow"&&i.nodeType==1&&(s=c(i,t,n)),!s||E(s,i,t,e)}while(i=i.nextSibling)}function x(e,t){var n=h(e,null,null,t);n.isExecutable?f=n.isExecutable=="true":f=!1,S(e,n,t),a.push(n),E(n,e)}function T(e,t,n,r){var i=h(e,t,n,r);S(e,i,r),E(i,e)}function N(e,t){var n={};n.type=e.localName;for(var r=0;e.attributes!=null&&r<e.attributes.length;r++){var i=e.attributes.item(r);i.nodeName!="bpmnElement"&&(n[i.nodeName]=i.nodeValue)}var s=[],o=e.firstChild;if(!!o)do N(o,s);while(o=o.nextSibling);s.length>0&&(n.children=s),t.push(n)}function C(e,n){var r;!!e.namespaceURI&&e.namespaceURI==t&&(r=e.getAttribute("bpmnElement"));var i=e.firstChild;if(!!i)do if(e.localName=="BPMNDiagram"||e.localName=="BPMNPlane")C(i,n);else{var s=[];N(e,s),n[r]=s}while(i=i.nextSibling)}function k(t,n){var r=[],i=t.getElementsByTagNameNS(e,"messageFlow");for(var s=0,o;!!(o=i[s]);s++){var u=c(o,null,n);r.push(u)}return r}function L(t,n){var r=[],i=t.getElementsByTagNameNS(e,"participant");for(var s=0;s<i.length;s++){var o=c(i[s],null,n);r.push(o)}return r}function A(t){var n=[],r=t.getElementsByTagNameNS(e,"categoryValue");if(r.length!=0)for(var i=0;i<r.length;i++){var s=c(r[i],null,[]);n.push(s)}return n}function O(t,n){var r=[],i=t.getElementsByTagNameNS(e,"dataInputAssociation"),s=t.getElementsByTagNameNS(e,"dataOutputAssociation");for(var o=0,u;!!(u=i[o]);o++)r.push(c(u,null,n));for(var a=0,f;!!(f=s[a]);a++)r.push(c(f,null,n));return r}function M(t,n){var r=[],i=t.getElementsByTagNameNS(e,"message");for(var s=0;s<i.length;s++){var o=c(i[s],null,n);r.push(o)}return r}function _(n){var r=n.getElementsByTagNameNS(t,"BPMNDiagram"),i={};for(var s=0;s<r.length;s++)C(r[s],i);var o=n.getElementsByTagNameNS(e,"process"),u={},f=L(n,i),l=A(n);a=l.concat(a.concat(f));for(var c=0,h;!!(h=f[c]);c++){if(!h.processRef)continue;i[h.processRef]=i[h.id],u[h.processRef]=h.name}for(var p=0,d;!!(d=o[p]);p++){var v=u[d.getAttribute("id")];v&&d.setAttributeNS(e,"name",u[d.getAttribute("id")]),x(d,i)}var m=k(n,i),g=O(n,i),y=M(n,i);return a.concat(m,g,y)}var r=this.parseListeners,s=i(n),u=s.getElementsByTagNameNS(e,"definitions");if(u.length==0)throw o("A BPMN 2.0 XML file must contain at least one definitions element");var a=[],f=!1,l=0;return _(u[0])},s}),define("bpmn/Engine",["bpmn/Executor","bpmn/Transformer"],function(e,t){return{startInstance:function(e,n,r){var i=new t;i.parseListeners.splice(0,i.parseListeners.length);var s=function(e){return function(t){e.id?t.id==e.id&&t.listeners.push(e):t.listeners.push(e)}};if(r)for(var o in r){var u=r[o];i.parseListeners.push(s(u))}var a=i.transform(e)[0],f=new CAM.ActivityExecution(a);return f.variables=n?n:{},f.start(),f}}});